/************************************************************************
* Copyright (c) 1995 Valentin Shopov, Blagoevgrad, Bulgaria		*
*									*
* Permission to use, copy, modify, and distribute this material for any	*
* purpose and without fee is hereby granted, provided that the above	*
* copyright notice and this permission notice appear in all copies, and	*
* that the name of the author not be used in advertising or publicity 	*
* pertaining to this material without the specific, prior written 	*
* permission of the author.						*
*									*
* THE AUTHOR MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY	*  
* OF THIS MATERIAL FOR ANY PURPOSE. IT IS PROVIDED "AS IS", WITHOUT ANY	* 
* EXPRESS OR IMPLIED WARRANTIES.					*
*************************************************************************/

/**************************ciilib1.0.7***********************************
 *									*
 *        Character to Inline Image Conversion Library (CIILIB)		*
 *									*
 *	Encoder for Character by Inline Image of HTML on HTTP		*
 *			by Valentin Shopov				*
 *			valentin@rs.aubg.bg				*
 ************************************************************************/

#include <stdio.h>
/*
int CII_isPRE;
*/
static int isTag, isTitle, isAnchor, is2inA, isIMG, isLAT, AncLen;
static char *inHTMLcs=(char *) 0, AncBuf[1024];

#if defined PLUS256C
extern char *chsetabbr[];
extern int numof256c;
extern char *xbmsrc_256[][257];
extern int xbmind_256[][257];
#else if
static char *chsetabbr[]={0};
static int numof256c=0;
static char *xbmsrc_256[1][257];
static int xbmind_256[1][257];
#endif

extern char *CharsetID(/* char *abbr */);

static int to256c(csname)
	char *csname;
{	char *charset;

	if( (charset = CharsetID(csname)) == NULL )
		return 0;
        return strncasecmp(charset,"ISO-8859-",9) == 0;
}
static int is256c(charsets)
	char *charsets;
{	int convnum,i;
	char *charset;

        if(numof256c && to256c(charsets) ){
        convnum=0;
        for(i=0;chsetabbr[i];i++){
		if( charset = CharsetID(chsetabbr[i]) )
                if( charset == CharsetID(charsets) ){
                        convnum=i;
                        break;
                }
        }
	}
        else convnum=-1;
        return(convnum);
}

unsigned char *
EUC_TO_CII(src,dst,ctype,charsets,ubase)
unsigned char *src, *dst;
char *ctype,*charsets[],*ubase;
{	register unsigned char *sp,*dp;
	char *charset,*charsetsII, *Achar;
	char inHTMLCC[32];
	int isPlain,do256,cs256,AncLen,i;

	isPlain = strcasecmp(ctype,"text/plain") == 0;

        charsetsII=(inHTMLcs)? inHTMLcs : charsets[0];

        charset = CharsetID(charsetsII);
        if( charset == NULL ){
                dst=src;
                return dst;
        }

        do256 = to256c(charsetsII);
        cs256 = is256c(charsetsII);

	for(sp=src, dp=dst; *sp; ){
/*
	if(CII_isPRE>0 && isPlain){
	sprintf(dp,"<PRE>");
	dp+=5;
	CII_isPRE=-1;
	}
*/	
	if(*sp == '<' && !isTag && !isPlain){
		
		isTag=1;
		if(!isAnchor && !strncasecmp(sp,"<A ",3)){ 
		for(i=0;sp[i]!='>';i++) {
			if(!isAnchor && !strncasecmp(sp+i," HREF=",6)){
			is2inA=isIMG=isLAT=0;
			isAnchor=1;
			}
			AncBuf[i]=sp[i];
			AncLen=i;
			}
			AncBuf[++AncLen]='>';
			AncBuf[++AncLen]='\0';
		}
		else
		if(isAnchor && !strncasecmp(sp,"</A>",4)){
			isAnchor=0;
			isTag=0;
		if(is2inA && !isLAT) sp+=4; 
		}
		else
		if(!strncasecmp(sp,"<!CIICC=",8)){
			sscanf(sp+8,"%[^>]",inHTMLCC);	
			free((void *)inHTMLcs);
			inHTMLcs=(char *)strdup(CharsetID(inHTMLCC));
		        charsetsII=(inHTMLcs)? inHTMLcs : charsets[0];
 		        charset = CharsetID(charsetsII);
 		        do256 = to256c(charsetsII);
 		        cs256 = is256c(charsetsII);

		}
		else 
		if(!strncasecmp(sp,"<!/CIICC>",9)){
			free((void *)inHTMLcs);
			inHTMLcs=(char *) 0;
                        charset = CharsetID(charsets[0]);
                        do256 = to256c(charsets[0]);
 		        cs256 = is256c(charsets[0]);

		}
		else
		if(!isTitle && !strncasecmp(sp,"<TITLE>",7)) isTitle = 1;
		else
		if(isTitle && !strncasecmp(sp,"</TITLE>",8)) isTitle = 0;
	}
	if(isTag || isTitle){
		if(*sp == '>' && isTag) isTag = 0;
		*dp++ = *sp++;
	}
	else{
		if( *sp & 0x80 ){
			if(isAnchor){
				isIMG=1;
				if(isLAT){
				isLAT=0;
                                sprintf(dp,"</A>");
                                dp+=4;
				}
				if(!is2inA){
				is2inA=1;
				Achar="";
				}
				else
				if(is2inA>0){
					sprintf(dp,"</A>");
					dp+=4;
					is2inA=-1;
				}
                        	if(is2inA<0) Achar="u";
			}
			else Achar="";
			
			if( do256 ){
			 if(cs256!=-1){
			  sprintf(dp,"<IMG SRC=\"%s%s/%s%02x%02x\">",ubase,charset,Achar,cs256,sp[0]);
		       	  dp += strlen(dp);
			 }
			 sp++;
			}
			else {
			if(sp[1] & 0x80){
				sprintf(dp,"<IMG SRC=\"%s%s/%s%x%x\">",ubase,charset,Achar,sp[0],sp[1]);
				dp += strlen(dp); sp += 2;
			}else	sp++;
			}
		}else{	if(isPlain){ switch(*sp) {
				case '<' : 
					sprintf(dp,"&lt;");
					dp += 4; sp++;
					break;
				case '>' : 
					sprintf(dp,"&gt;");
					dp += 4; sp++;
					break;
				case '&' : 
					sprintf(dp,"&amp;");
					dp += 5; sp++;
					break;
				case '"' : 
					sprintf(dp,"&quot;");
					dp += 6; sp++;
					break;
				default:
					*dp++ = *sp++;
					break;
				    }
			}else {
				if(isAnchor){
					if(isIMG){
					if(*sp==' '){
						sprintf(dp,"<IMG SRC=\"%suSPACE\">",ubase);
						dp+=strlen(dp); sp++;
					}
					else{
						isLAT=1;
						isIMG=0;
						strncpy(dp,AncBuf,AncLen);
						dp+=AncLen;
						*dp++ = *sp++;
					}
					} else *dp++ = *sp++;
				}
				else *dp++ = *sp++;
			 }
		}
	}
	}
	*dp = 0;
	return dst;
}
CII_toCII(any,gr,ctype,charsets,ubase)
	unsigned char *any,*gr;
	char *ctype,*charsets[];
	char *ubase;
{	char *euc,*iifl;
	int i;
	char *charsetsII;
	charsetsII=(inHTMLcs)? inHTMLcs  : charsets[0]; 	
        if( to256c(charsetsII) ) EUC_TO_CII(any,gr,ctype,charsets,ubase);
	else{
	euc = (char*)malloc(strlen(any)+1);
	TO_EUC(any,euc);
	EUC_TO_CII(euc,gr,ctype,charsets,ubase);
	free(euc);
	}
}

extern char *xbmsrc[];
extern int xbmind[];
static char *getCII_JIS(name,xbmbuf)
	char *name,*xbmbuf;
{	int i,euc,kanind,isU;
	char *gkand,*curxbm;
	gkand = xbmbuf;
	isU=(*name=='u')? 1: 0;
	sscanf((isU)?name+1 : name,"%x",&euc);
	kanind=(euc/256-161)*94 + euc%256-161;
	if(xbmind[kanind] == -1) return 0;
	curxbm = xbmsrc[xbmind[kanind]];
	sprintf(gkand,"#define %s_width 16\n#define %s_height %d\nstatic char %s_bits[] = {\n\0",name,name,(isU)? 18: 16,name);
	for(i = 0; i< 32; i++) {
	sprintf(gkand+strlen(gkand),"0x%02x,\0",(unsigned char)curxbm[i]);
	}
	if(isU) sprintf(gkand+strlen(gkand),"0x00,0x00,0xff,0xff,\0");
	sprintf(gkand+strlen(gkand)-1,"};\n\0");
	return gkand;
}

static char *getCII_256(name,xbmbuf)
        char *name,*xbmbuf;
{       int i,code,cindr,cindc,isU;
        char *gchd,*curxbm;
        gchd = xbmbuf;
        isU=(*name=='u')? 1: 0;
        sscanf((isU)?name+1 : name,"%x",&code);
        cindr=code/256; cindc=code%256; 
	if(cindr>numof256c || xbmind_256[cindr][cindc] == -1) return 0;
        curxbm = xbmsrc_256[cindr][xbmind_256[cindr][cindc]];
        sprintf(gchd,"#define %s_width 8\n#define %s_height %d\nstatic char %s_bits[] = {\n\0",name,name,(isU)? 18: 16,name);
        for(i = 0; i< 16; i++) {
        sprintf(gchd+strlen(gchd),"0x%02x,\0",(unsigned char)curxbm[i]);
        }
        if(isU) sprintf(gchd+strlen(gchd),"0x00,0xff,\0");
        sprintf(gchd+strlen(gchd)-1,"};\n\0");
        return gchd;
}
char *CII_getXBM(name,xbmbuf)
	char *name, *xbmbuf;
{	char charset[32],code[32];
	char *getCII_JIS(),*getCII_256(),*gchd;
	int i;

	sscanf(name,"%[^/]/%s",charset,code);
	if(!strncmp(name,"uSPACE",3)){
	gchd=xbmbuf;
        sprintf(gchd,"#define uSPACE_width 8\n#define uSPACE_height 18\nstatic char uSPACE_bits[] = {\n\0");
        for(i = 0; i< 17; i++) {
        sprintf(gchd+strlen(gchd),"0x00,\0");
        }
        sprintf(gchd+strlen(gchd),"0xff};\n\0");
	return gchd;
	}

	if( to256c(charset) )
		return getCII_256(code,xbmbuf);
	else	return getCII_JIS(code,xbmbuf);
}

CII_putHTTP(tc,vno,gkan)
	FILE *tc;
	char *gkan;
{	char *data;
	int size;
	int leng = 0;
	char xbmbuf[500];

	if( (data = CII_getXBM(gkan,xbmbuf)) == 0 )
		return 0;

	size = strlen(data);
	leng += HTTP_putHeader(tc,vno,"image/x-xbitmap",size);
	leng += fwrite(data,1,size,tc);
	return leng;
}

